<!DOCTYPE html>
<html lang="en">
    <head>
        <title>Tries and Suffix Tries Experiment</title>
        <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
        <meta charset="utf-8" />
        <style>
         .exp {
             display:none;
         }
         table {
             font-family: arial, sans-serif;
             border-collapse: collapse;
             width: 100%;
             text-align: center;
         }
         th {
             background-color:#2780C6;
             text-align: center !important;
             color:#fff;
         }
         #headings {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         td {
             border: 1px solid #dddddd;
             padding: 8px;
             text-align: center;
             height:20px;
         }
         tr:hover {
             background-color: #ddd;
         }
        </style>
        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': 'Tries and Suffix Trees',
          'expShortName': 'tries-suffix-trees'
          });
          

          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var
          f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
          })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
        <!-- End Google Tag Manager -->
    </head>

    <body>
      <!-- Google Tag Manager (noscript) -->
       <noscript class="gtm">
         <iframe height="0" width="0"
           src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
           style="display:none;visibility:hidden">
         </iframe>
       </noscript>
       <!-- End Google Tag Manager (noscript) -->

        <!--The Introduction Page-->
        <div class="exp" title="Tries and Suffix Experiment">
            <div class="longt">
                <h1 class="hlongt"> Introduction to Tries</h1>
            </div>
            <div class="preamble">
                <div class="art txt" title="Estimation">
                    <div class="longt">
                        <h2 class="hlongt">Estimated Time</h2>
                    </div>
                    <div class="art-body">
                        <p>1.5 hours</p>
                    </div>
                </div>

                <div class="art req" title="Introduction Video">
                    <div class="longt">
                        <h2 class="hlongt">A Short Introduction to the Overall Experiment</h2>
                    </div>
                    <div class="description">
                        <p>Introduction video for Tries and Suffix Tries.</p>
                    </div>
                </div>

                <div class="art txt" title="Prerequisites">
                    <div class="longt">
                        <h2 class="hlongt">Prerequisites of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>
                            This experiment requires you to have basic knowledge
                            about :</p>
                        <ul>
                            <li><a href="https://en.wikipedia.org/wiki/Tree_(data_structure)">What
                                a Tree is (parent, child, subtree in a tree)</a></li>
                            <li><a href="https://www.enchantedlearning.com/grammar/prefixsuffix/index.shtml">What
                                Prefixes and Suffixes of a word are</a></li>
                            <li><a href="https://en.wikipedia.org/wiki/Time_complexity">A
                                basic understanding of what space and time complexity is</a></li>
                        </ul>
                        <p>And above all, a curiosity to learn and explore!</p>
                    </div>
                </div>

                <div class="art txt" title="Overview">
                    <div class="longt">
                        <h2 class="hlongt">Overview of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <ul>
                            <li>
                                This experiment aims to help understand what a Trie data
                                structure is and how it can be used to store words and find words
                                in that list in a manner that is both space and time efficient.
                            </li>
                            <li>
                                The experiment features a series of modules with video lectures,
                                interactive demonstrations, simulations, hands-on practice
                                exercises and quizzes for self analysis.
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="art txt" title="Learning Objectives">
                    <div class="longt">
                        <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>In this experiment, you will be able to do the following:</p>
                            <ul>
                                <li>Given a pre-build Trie, search for a given word in it.</li>
                                <li>Given a list of words, build a Trie.</li>
                                <li>Understand the use of Tries in a practical situation of String Pattern matching.</li>
                            </ul>
                    </div>
                </div>

                <div class="art txt" title="Modules and Weightage">
                    <div class="longt">
                        <h2 class="hlongt">Experiment Modules and their Weightage</h2>
                    </div>
                    <div class="art-body">
                        <table width=100%>

                            <thead>
                                <tr>
                                    <th>Module</th>
                                    <th>Weightage</th>
                                    <th>Expectation</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>Pre-Test</td>
                                    <td>10%</td>
                                    <td>Solve All questionss</td>
                                </tr>
                                <tr>
                                    <td>Searching in Tries</td>
                                    <td>30%</td>
                                    <td>Understand how to find words in a Trie</td>
                                </tr>
                                <tr>
                                    <td>Inserting into a Trie</td>
                                    <td>30%</td>
                                    <td>Understand how to add words to a Trie</td>
                                </tr>

                                <tr>
                                    <td>Suffix Tries</td>
                                    <td>10%</td>
                                    <td>Understand the real world use of Suffix Tries</td>
                                </tr>
                                <tr>
                                    <td>Post-test</td>
                                    <td>20%</td>
                                    <td>Solve all Questions</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>

            <div class="lu" title="Pre-Test">
                <div class="longt">
                    <h1 class="hlongt">Pre-Test of the Experiment</h1>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>

                    <div class="art txt" title="Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Pre-Test</h2>
                        </div>
                        <div class="art-body">
                            <ul>
                                <li>Pretest includes questions on <strong>what prefix and suffix
                                    are and parent-child relationships in trees.</strong></li>
                                <li>If you want to revise these topics before taking the quiz, go
                                    through the Recap module first.</li>
                                <li>Read the questions in the quiz section and select the correct
                                    option from the ones provided. Please note that some <strong>questions
                                    may have more than one correct response.</strong>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Recap">
                    <div class="longt">
                        <h2 class="hlongt">Quick look at Sorting, Time and Space
                            Complexity</h2>
                    </div>

                    <div class="art txt" title="Sorting">
                        <div class="longt">
                            <h2 class="hlongt">What is a Tree?</h2>
                        </div>
                        <div class="art-body">
                            <p>A tree is a Data Structure which is arranged in the form of
                                multiple nodes holding some data, connected to each other as in
                                the figure below. The node at the top is called the root. All
                                the nodes reachable from it, below it, are it's children,
                                and the node connected to it, directly above it, i.e. on the path
                                to the root is it's parent.</p>
                        </div>
                    </div>

                    <div class="art req" title="Tries Prerequisites">
                        <div class="longt">
                            <h2 class="hlongt">A Tree</h2>
                        </div>
                        <div class="description">
                            Picture showing parent-child relationships in a Tree.
                        </div>
                    </div>

                    <div class="art txt" title="Time and Space Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Time and Space Complexity</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>
                                Time complexity of an algorithm gives the measure of
                                time taken by it to run as a function of the length of
                                the input. Similarly, Space complexity of an algorithm
                                quantifies the amount of space or memory taken by an
                                algorithm to run as a function of the length of
                                the input. </li>
                                <li>
                                Recall that if our word list (the one we are searching through) is
                                an array of length N, and our algorithm iterates through the array
                                once, then time complexity will be O(N). If for each element we have to
                                perform m operations, where m is the length of the word, then the
                                algorithm is O(NM). </li> 
                            </ul>
                            </p>
                        </div>
                    </div>

                </div>
                <div class="quiz" title="Pre-Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which of the following is a prefix of the word
                                        'ABRACADABRA'?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) CADABRA</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) ABRA</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) ABARD</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) ABRACAD</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>A prefix of a word is a collection of letters that appears at the start of a word.</p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. How many parents can each node (not the Root) of a Tree
                                        of Size N can have?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) N-1 Parents</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) Upto N^2 parents</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) 1 Parent</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) 0 Parents</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>A tree is a graph where every node has one and only one
                                        parent, though one node may have multiple children.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. How many parents does the root of a tree of size N can have?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c1">
                                    <div class="art-body">
                                        <p>(A) N-1 Parents</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c2">
                                    <div class="art-body">
                                        <p>(B) Upto N^2 parents</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c3">
                                    <div class="art-body">
                                        <p>(C) 1 Parent</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q3-c4">
                                    <div class="art-body">
                                        <p>(D) 0 Parents</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>A tree is a graph where every node has one and only one
                                        parent, though one node may have multiple children.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. int a = 0, b = 0; <br>
                                        for (i = 0; i &lt; N; i++) {<br>
                                        a = a + rand();<br>
                                        }<br>
                                        for (j = 0; j &lt; M; j++) {<br>
                                        b = b + rand();<br>
                                        }<br>
                                        What is the time and space
                                        complexity for the above code?</h2>
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(N * M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(N + M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(N + M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) O(N * M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The first loop runs for O(n) time, second
                                        loop runs for O(m).
                                        Constant extra space is used for 2
                                        variables a and b, hence O(1) space.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>

            <!-- LU: Seaching in Tries (module) -->
            <div class="lu" title="Searching in Tries">

                <!-- HED: Tries Searching Introduction (submodule) -->
                <div class="longt">
                    <h2 class="hlongt">What are Tries?</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>30 minutes</p>
                        </div>
                    </div>

                    <div class="art req" title="Tries Searching">
                        <div class="longt">
                            <h2 class="hlongt">Searching in Tries: Concept</h2>
                        </div>
                        <div class="description">
                            <p>Video for Searching in Tries</p>
                        </div>
                    </div>

                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module:</h2>
                        </div>
                        <div class="art-body">
                            <p>In this module, we will:</p>
                            <ul>
                                <li>See an example of a trie.</li>
                                <li>Observe how any word can be inserted into and searched from a
                                    trie.</li>
                                <li>Learn the algorithm to search for words in the trie.</li>
                                <li>Learn when to report failure in searching for a word.</li>
                                <li>Practice the algorithm.</li>
                                <li>Test your conceptual understanding with a short quiz.</li>
                            </ul>
                        </div>
                    </div>
                </div>

                <!-- TSK: Seaching in Tries - Concept (submodule) -->
                <div class="task" title="Basic Concept">
                    <div class="longt">
                        <h2 class="hlongt">What are Tries and how do they help in searching</h2>
                    </div>
                    <div class="art txt" title="Naive Approach">
                        <div class="longt">
                            <h2 class="hlongt">Search a word from a list - Naive Approach</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Let's say we have a huge list of words, for example a Dictionary
                                (Here in this example our list is [CAT, CAP, CAN, CADET]). You
                                want to find out whether or not a word, let's say CABLE, is in
                                this list. The naive approach to solving this problem is as
                                follows.
                                <ul>
                                    <li>Store all the words in the list into separate arrays /
                                        linked lists / any data structure, as done in the figure on
                                        the left below.</li>
                                    <li>When the new word comes, go through each word in the list
                                        and try to match it. Report a match if there is one, else a failure.</li>
                                </ul>
                            </p>
                            <p>
                                We notice here that it is takes a lot of steps to search a
                                word, and that we waste a lot of memory. Notice all the words that             start with a  'C' followed by an 'A', for which we sort those letters over
                                and over again for each word. Let's try to improve our approach.
                            </p>
                        </div>
                    </div> 

                    <div class="art req" title="Use of Tries">
                        <div class="longt">
                            <h2 class="hlongt">Why Tries should be used</h2>
                        </div>
                        <div class="description">
                            Image showing how Tries can outperform linked list in searching
                            words.
                        </div>
                    </div>

                    <div class="art txt" title="What is a Trie?">
                        <div class="longt">
                            <h2 class="hlongt">So what is a TRIE?</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                The way we, as humans, approach looking at words in a
                                dictionary, is that we try to find the first letter 'C', then in
                                the pages starting with 'C', we try and find 'A', then 'B', then
                                'L', and 'E'. We want to take the same approach in our algorithm.

                                We can optimize our search in the following way:
                                <ul>
                                    <li>
                                        We can merge all the common letters, that is if two words
                                        have a common prefix, then the prefix would be stored once
                                        and the words will branch out of it. (saves memory).
                                    </li>
                                    <li>
                                        We can now search in one go. We see that all words start
                                        with a 'C', followed by an 'A', hence we can try finding 'B', and report failure upon it not being there. This is the approach taken by a common man to solve this problem. 
                                    </li>
                                </ul>
                                You can see the illustration of this tree like method (A TRIE),
                                in the image on the right. <b>A trie is nothing but a Tree of
                                    letters, where each path from the root to the leaves represents
                                    a word that is made up of all the letters that were found on
                                    it's path.</b> It helps us solve the problem of searching words
                                in a list quickly.
                            </p>
                        </div>
                    </div>

                </div>

                <!-- TSK: The Search Algorithm (Submodule) -->
                <div class="task" title="Search Algorithm">
                    <div class="longt">
                        <h2 class="hlongt">How to Search in a Trie</h2>
                    </div>

                    <div class="art req" title="Tries Searching Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Search Algorithm</h2>
                        </div>
                        <div class="description">
                            <p>Video for searching in a trie</p>
                        </div>
                    </div>

                    <div class="art txt" title="Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Algorithm</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                <ul>
                                    <li>We start at the Root Node.</li>
                                    <li>We move to each of it's children and match the first letter
                                        of our word with them.</li>
                                    <li>If none of the children match, then we report that the word
                                        is not in the list.</li>
                                    <li>If one of the children match, then we take that as our new
                                        node, and compare it's children with the second letter.</li>
                                    <li>We keep doing this until we are out of letters in the word
                                        we are searching for, and finally when the last letter is
                                        matched, we try to match an end-point '$'. If it's there,
                                        then the word exists, otherwise it does not.</li>
                                </ul>
                                This is the algorithm for searching. Let's now try to understand why we
                                need endpoints.
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Use of Endchars">
                        <div class="longt">
                            <h2 class="hlongt">Why $ is needed</h2>
                        </div>
                        <div class="description"><br><br>
                            Image showing difficulty of searching words without end character.
                        </div>
                    </div>

                    <div class="art txt" title="Why $ is needed">
                        <div class="longt">
                            <h2 class="hlongt">Why $ is needed</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                We have added a '^' to the start of each word and a '$' to the
                                end. This is to solve the problem which is shown in the image above.
                                Say there are two words HELL and HELLO in our list. One word
                                (Hell) is the prefix of another (Hello). Now if we try to seach
                                for HELL, we will match each letter, but we will never be able to
                                tell if HELL was in the Trie, or it was there only because HELLO
                                was there. We solve this by adding a $ to the end of each word,
                                so that we can then check if there was a word HELL that ended there
                                by also matching an end character '$'. We add the start char '^' so
                                that all words can have a common root, thus making this a
                                convienient tree to code up, with one root.
                            </p>
                        </div>
                    </div>

                </div>

                <!-- EXP: Insert and Search in Tries - Demo (Submodule) -->
                <div class="task" title="Working with Tries: Demo">
                    <div class="longt">
                        <h2 class="hlongt">Demo: Insertions and Search in tries</h2>
                    </div>

                    <div class="art req" title="Demo: Working with Tries">
                        <div class="longt">
                            <h2 class="hlongt">Demo : Working with Tries</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where user can type in a word
                                and ask for it to be inserted into the trie or
                                searched for in the trie.</p>
                        </div>
                    </div>
                </div>

                <!-- EXP: Tries Searching - Practice (Submodule) -->
                <div class="task" title="Searching in Tries: Practice">
                    <div class="longt">
                        <h2 class="hlongt">Step by Step Practice for Searching in Tries</h2>
                    </div>

                    <div class="art req" title="Practice: Searching in Tries">
                        <div class="longt">
                            <h2 class="hlongt">Practice : Searching in Tries</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where user can click through the letters in
                                a try trying to find a word and see the letters get highlighted
                                in green if correct and red if wrong.</p>
                        </div>
                    </div>
                </div>

                <!-- EXP: Tries Searching - Exercise (Submodule) -->
                <div class="task" title="Searching in Tries: Exercise">
                    <div class="longt">
                        <h2 class="hlongt">Hands on Exercise for Searching in Tries</h2>
                    </div>

                    <div class="art req" title="Exercise: Searching in Tries">
                        <div class="longt">
                            <h2 class="hlongt">Exercise : Seaching in Tries</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where user can try to find words generated
                                by a computer </p>
                        </div>
                    </div>
                </div>

                <!-- MCQ: Tries Searching - Quiz (Submodule) -->
                <div class="quiz" title="Searching in Tries: Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Revision Quiz for Bubble Sort</h2>
                    </div>
                    <!-- Quiz Question 1 -->
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Upto how many children can each node in the trie have?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) 26 (As many letters as in the Alphabet)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) 27 (As many letters as in the Alphabet + 1)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Depends on the size of the longest word</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Depends on the size of the shortest word</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The number of children every node has can be any of the
                                        unique letters in the alphabet, which is A-Z and the
                                        termination character '$'. It has nothing to do with the
                                        length of the words. The length decides the depth, not the
                                        breadth.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Quiz Question 2 -->
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. The number of '$' characters in a Trie equals:</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) The number of letters in the alphabet</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) The number of insert operations performed.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) The number of search operations performed.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) The number of unique words entered into the Trie</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Each unique word (only the unique inserts) added to the trie
                                        end in a '$', therefore the number of words and the number of
                                        '$' characters are the same.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Quiz Question 3 -->
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. If the letters '^', 'A', 'N', 'T', are encountered
                                        consecutively when searching but there is no '$' attached
                                        directly to the letter 'T', then which of the following are
                                        true?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c1">
                                    <div class="art-body">
                                        <p>(A) The Word "ANT" is present in the Trie and has been
                                            found.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c2">
                                    <div class="art-body">
                                        <p>(B) The Word "ANT" might be present somewhere else in the
                                            Trie but has not been found.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q3-c3">
                                    <div class="art-body">
                                        <p>(C) The Word "ANT" is not present, but other words
                                            starting with the letters "ANT..." might be.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c4">
                                    <div class="art-body">
                                        <p>(D) The word ANT is not present, and is not the prefix or
                                            suffix of any other string.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>If there is no '$' at the end of the search for 'ANT', then
                                        the word does not exists in the trie, but others with that
                                        prefix certainly do. This is the whole use of using the
                                        terminal character '$'.</p>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- LU: Inserting into Tries (modules) -->
            <div class="lu" title="Inserting into Tries">

                <!-- HED: Tries Searching Introduction (submodule) -->
                <div class="longt">
                    <h2 class="hlongt">Add words to a Trie</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>20 minutes</p>
                        </div>
                    </div>

                    <div class="art req" title="Tries Introduction">
                        <div class="longt">
                            <h2 class="hlongt">Introduction</h2>
                        </div>
                        <div class="description">
                            <p>Introduction video for Tries and Suffix Tries.</p>
                        </div>
                    </div>

                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module: </h2>
                        </div>
                        <div class="art-body">
                            <p>In this module, we will: </p>
                            <ul>
                                <li>Learn how to insert a new word into a Trie</li>
                                <li>Optimize the trie to occupy less space</li>
                                <li>Practice adding in new words (Point of Insertion)</li>
                                <li>Test your conceptual understanding with a short quiz</li>
                            </ul>
                        </div>
                    </div>
                </div>

                <!-- TSK: Procedure for Inserting into Tries (Submodule) -->
                <div class="task" title="How to Insert">
                    <div class="longt">
                        <h2 class="hlongt">How to Insert words into a Trie</h2>
                    </div>

                    <div class="art txt" title="Insertion Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Insertion Algorithm</h2>
                        </div>
                        <div class="art-body">
                            <br />
                            <p>We have understood what a trie is and how we can use one to search
                                for words. Now let's take a look into how we can contruct a trie
                                out of a collection of words by inserting each word into the trie
                                one by one:</p>
                            <ul>
                                <li>
                                    Convert any given string <b>[WORD] into [^WORD$]</b>,
                                    where the ^ character denotes start of the word and $ denotes
                                    the end of the word. <small>This is important as we have seen
                                    in the tries explanation, where one word is the prefix of
                                    another, eg. ANT and ANTLER, and we need to find whether ANT
                                    is present in the Trie or not.</small>
                                </li>
                                <li>
                                    We search for the letters one by one, and keep matching till
                                    they (the current prefix) are present in the trie. We stop as
                                    soon as we see the first letter that cannot be matched in the
                                    trie.
                                </li>
                                <li>
                                    Now we branch out from the letter till where we matched, and
                                    add the new letter that could not be matched.
                                </li>
                                <li>
                                    Now we keep adding all the remaining letters as children of the
                                    current letter which we are on, until the whole word is done and we then add a "$' to it.
                                </li>
                            </ul>
                        </div>
                    </div>

                    <div class="art req" title="Insertion Algorithm Image">
                        <div class="longt">
                            <h2 class="hlongt">Step by Step process</h2>
                        </div>
                        <div class="description">
                            <p>Image of the 4-step algorithm of inserting a word in a trie</p>
                        </div>
                    </div>

                </div>

                <!-- EXP: Insertion in Tries - Demo (Submodule) -->
                <div class="task" title="Insertion in Tries: Exercise">
                    <div class="longt">
                        <h2 class="hlongt">Demonstration for Insertion in Tries</h2>
                    </div>

                    <div class="art req" title="Exercise: Insertion in Tries">
                        <div class="longt">
                            <h2 class="hlongt">Demo for Insertion in Tries</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where user is tasked with finding the
                                insertion points of words in a trie and can click the node of
                                insertion and then node that will be inserted.</p>
                        </div>
                    </div>
                </div>

                <!-- TSK: Optimization Method - Path Compression (Submodule) -->
                <div class="task" title="Path Compression">
                    <div class="longt">
                        <h2 class="hlongt">Optimizing the Trie with Path Compression</h2>
                    </div>

                    <div class="art txt" title="Termination of Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Can we store more Data in each node?</h2>
                        </div>
                        <div class="art-body">
                            <br />
                            <p>
                                Again in our Trie, we see that there are multiple nodes each
                                storing one letter, and only having one child. This is a waste of
                                memory, since we can lower the number of nodes by a lot, if every
                                <b>single unbranched path could be compressed in a single node as
                                    below.</b>.
                                <small> This idea would be extremely useful when we are working
                                    with text containing many words, and we need to look for
                                    patterns (In this way, we will be able to store only the start and end
                                    positions of these words making our nodes smaller - Don't worry
                                    if you don't understand - The idea will bear an elaborated explanation in
                                    Suffix Tries.)</small>
                            </p>

                        </div>
                    </div>

                    <div class="art req" title="Path Compression">
                        <div class="longt">
                            <h2 class="hlongt">A Compressed Trie</h2>
                        </div>
                        <div class="description"><br><br>
                            Image showing a sample compressed Trie.
                        </div>
                    </div>

                    <div class="art txt" title="Memory Required">
                        <div class="longt">
                            <h2 class="hlongt">Bounds on Complexity</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Now we can prove stronger upper bounds on the memory complexity
                                of the Trie.
                                <ul>
                                    <li>All internal nodes of such a trie <b>are branching</b> (has
                                        atleast 2 children)</li>
                                    <li>Each new unique word <b>adds only one Leaf Node</b> (a '$'
                                        sign at the end)</li>
                                    <li>If there are N words, then the number of leaves is O(N) and
                                        number of internal nodes is also O(N), using the properties
                                        of a Tree. Therefore, <b>total number of nodes is O(N)</b>.</li>
                                </ul>
                            </p>
                            This is a very crucial observation, and helps incredibly in
                            many search operations.
                        </div>
                    </div>

                </div>

                <!-- MCQ: Quiz on Insertions in Tries (Submodule) -->
                <div class="quiz" title="Insertion in Tries: Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with
                            Multiple Choice Questions</h2>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. There is a Trie with the words [ CAT, CAGGLE, COG,
                                        CANOPY, CATIS ]. How many nodes does this Trie have including
                                        the start and end nodes?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) 5 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) 16 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) 21 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) 22 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The words are [ CAT, CAGGLE, COG, CANOPY, CATIS ]. When we
                                        insert CAT, we get 5 letters, ^CAT$. Then when we add CAGGLE,
                                        we add 5 letters again, GGLE$. we add COG with 3 letters OG$,
                                        then CANOPY with 5 letters NOPY$ and finally CATIS with 3
                                        letters IS$. So the total is 5 + 5 + 3 + 5 + 3 = 21 nodes.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. What is the memory complexity of a Trie with no path
                                        compression?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(Number of Words)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(Length of the Longest Word)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(Sum of Lengths of Words)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) O(Total Number of Unique Characters)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The worst case scenario is that none of the nodes get merged
                                        where we have each node containing a letter, so the number of
                                        letters is at max the sum of lengths of all words.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. In the Trie with words [ HELLO, HELSINKI, HILBERT ] we
                                        are adding in the word HILLS. How many nodes will be created
                                        and added in this process?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c1">
                                    <div class="art-body">
                                        <p>(A) 0 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c2">
                                    <div class="art-body">
                                        <p>(B) 5 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c3">
                                    <div class="art-body">
                                        <p>(C) 2 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q3-c4">
                                    <div class="art-body">
                                        <p>(D) 3 Nodes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c5">
                                    <div class="art-body">
                                        <p>(E) 1 Node</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>^HIL is already present, so we need to add in LS$, which is
                                        3 new letters, 3 new nodes.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- LU: Suffix Tries (Module) -->
            <div class="lu" title="Suffix Tries">
                <div class="longt">
                    <h2 class="hlongt">Solving String Search</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>20 minutes</p>
                        </div>
                    </div>

                    <div class="art req" title="Suffix Tries Introduction">
                        <div class="longt">
                            <h2 class="hlongt">Introduction</h2>
                        </div>
                        <div class="description">
                            <p>Introduction video for Suffix Tries.</p>
                        </div>
                    </div>

                    <div class="art req" title="Suffix Trie for ABRACADABRA">
                        <div class="longt">
                            <h2 class="hlongt">Suffix Trie for ABRACADABRA.</h2>
                        </div>
                        <div class="description">
                            <p>Image showing an example of a Suffix Tree.</p>
                        </div>
                    </div>

                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module: </h2>
                        </div>
                        <div class="art-body">
                            <p>In this module, we will learn: </p>
                            <ul>
                                <li>What a Suffix Tree is</li>
                                <li>A naive method of creating a suffix tree</li>
                                <li>Idea of how to solve string searching using a suffix tree</li>
                                <li>Use of Suffix Tries in the real world</li>
                                <li>Understand the maximum complexity of the Suffix Tree</li>
                            </ul>
                        </div>
                    </div>
                </div>

                <!-- TSK: Suffix Tries - Demo (Submodule) -->
                <div class="task" title="Suffix Tries: Motivation">
                    <div class="longt">
                        <h2 class="hlongt">Demo for how Suffix Tries are created for a String</h2>
                    </div>

                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Finding Patterns in a String</h2>
                        </div>
                        <div class="art-body">
                            <p>Now that we know how to search for a string in a list of
                                strings, let's turn to finding a pattern (a string or a
                                regular expression) in a huge bulk of text. This is what you do
                                when you press CTRL+F to search in Microsoft Word. Lets try to
                                see how we would achieve this:</p>
                            <ul>
                                <li>We already know how to find a word in a huge list.</li>
                                <li>If we do not match till '$', we can also find any prefix in a
                                    list of words.</li>
                                <li>If our list is the set of all suffixes of a string, then we
                                    can match any prefix of suffix.</li>
                                <li>Any prefix of suffix is a substring, so we want to take the
                                    list of all suffixes of our text and match any prefix of it.</li>
                                <li>We can use a compressed trie to store this in O(n) space,
                                    since there are O(n) unique suffixes in a text of length n.</li>
                            </ul>
                        </div>
                    </div>
                    <div class="art req" title="Search in VScode">
                        <div class="longt">
                            <h2 class="hlongt">Search in a Text editor can be implemented this
                                way.</h2>
                        </div>
                        <div class="art-body">
                            <p>Image of Example search in a text editor showing multiple
                                results.</p>
                        </div>
                    </div>
                </div>

                <!-- EXP: Suffix Tries - Demo (Submodule) -->
                <div class="task" title="Suffix Tries: Demo">
                    <div class="longt">
                        <h2 class="hlongt">Demo for how Suffix Tries are created for a String</h2>
                    </div>

                    <div class="art req" title="Demo: Suffix Tries">
                        <div class="longt">
                            <h2 class="hlongt">Exercise: Suffix Tries</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact that take a word and generates it's Suffix
                                Tree.</p>
                        </div>
                    </div>
                </div>

            </div>

            <!-- LU: Post Test (Module) -->
            <div class="lu" title="Post Test">
                <div class="longt">
                    <h2 class="hlongt">Post Test of the Experiment</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>

                    <div class="art txt" title="Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Quiz</h2>
                        </div>
                        <div class="art-body">
                            <p>Post Test includes questions on entire experiment concepts. Read
                                the questions in the quiz section and select the correct option
                                from the ones provided. Please note that some questions may have
                                more than one correct response.
                            </p>
                            <p><b>ADVICE: Do sit with a Pen and a Paper, you may need to draw
                                out some Tries while answering these questions.</b></p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Post Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. How many children would the root (^) have in the suffix
                                        tree of the word "SHESELLSSEASHELLS"?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) 3</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) 5</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) 13</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) 17</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The number of unique children of the root is the number of
                                        unique characters in the string, that is 5 (S, H, E, A, L).
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. In the suffix tree of "SHESELLSSEASHELLS", S is a child
                                        of the root. How many direct children does this node
                                        containing S have?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) 3 (H, E, S)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) 3 (H, E, A)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) 4 (S, H, E, A)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) Only 1 child</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The letter S appears in the string followed by H, E and S
                                        only, therefore those are it's 3 children.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. If you have a text file of n characters containing words
                                        all of which are under k characters in length, and you want
                                        to search for a word of length less than m in it, what can be
                                        the estimated complexity of this search? (Answers are in the
                                        form &lt;PreprocessingTime, SearchTime&gt;) Note: We are only
                                        trying to search for complete words, not patterns.
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c1">
                                    <div class="art-body">
                                        <p>(A) &lt;O(N), O(K)&gt;</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q3-c2">
                                    <div class="art-body">
                                        <p>(B) &lt;O(N), O(M)&gt;</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c3">
                                    <div class="art-body">
                                        <p>(C) &lt;O(NK), O(M)&gt;</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q3-c4">
                                    <div class="art-body">
                                        <p>(D) &lt;O(K), O(M)&gt;</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>For text of length N, it takes O(N) steps to insert all the
                                        words in a trie. Then to search in it for a word of length M,
                                        we need O(26 M) = O(M) steps.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. Which of the following tasks can a Trie or a Suffix Tree
                                        be used for? (Select ALL that apply)</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q4-c1">
                                    <div class="art-body">
                                        <p>(A) In the Search feature of Microsoft Word.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q4-c2">
                                    <div class="art-body">
                                        <p>(B) In sorting emails based on date.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q4-c3">
                                    <div class="art-body">
                                        <p>(C) In Matching <a href="https://en.wikipedia.org/wiki/Regular_expression">>Regular
                                            Expressions</a>. (Patters of Text)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q4-c4">
                                    <div class="art-body">
                                        <p>(D) Finnding synonyms from a Dictionary</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q4-c5">
                                    <div class="art-body">
                                        <p>(E) Suggesting autocomplete as you are typing.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>We can use Suffix Tries for searching regular strings in a
                                        text editor, or in matching regular expressions (patterns -
                                        strings that have *, ., etc to represent any character or a
                                        group of characters). We can also use them for predictive
                                        text - all the words you ususally type form a Trie, and when
                                        you search for a part of a word that you have already typed
                                        out, all the members of the subtree of the result of the
                                        search are possible words you may want to type.</p>
                                </div>
                            </div>
                        </div>
                    </div> 
                </div>
            </div>

            <!-- <div class="lu" title="Feedback">
                <div class="longt">
                    <h2 class="hlongt">Feedback of the
                        Experiment</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Feedback Form">
                        <div class="longt">
                            <h2 class="hlongt">Feedback
                                Form of the Experiment</h2>
                        </div>
                        <div class="art-body">
                            <p>The experiment ends here,thanks for participating! Please fill
                                up the form.</p>
                        </div>
                    </div>
                </div>
            </div> -->

            <div class="lu" title="Further Readings/References">
                <div class="longt">
                    <h2 class="hlongt">Further Readings and References of the Experiment</h2>
                </div>

                <div class="preamble">

                    <div class="art txt" title="Explore">
                        <div class="longt">
                            <h2 class="hlongt">Explore More on Tries and Suffix Tries</h2>
                        </div>
                        <div class="art-body">
                            <p>You can explore more about Tries through following resources:
                            </p><br>
                            <p>
                                <b>Useful Links :</b>
                                <ul>
                                    <li><a href="https://medium.com/basecs/trying-to-understand-tries-3ec6bede0014">Medium
                                        Blog: A Basic review of what Tries are and links to some
                                        more incredible resources.</a></li>
                                    <li><a href="https://www.youtube.com/watch?v=TRg9DQFu0kU">Video
                                        explaining the concept of Tries</a></li>
                                    <li><a href="https://brilliant.org/wiki/tries/">Tutorial on
                                        Tries by Brillant.org with Code in Python</a></li>
                                    <li><a href="https://www.topcoder.com/community/competitive-programming/tutorials/using-tries/">Advanced
                                        blog on Coding up a Trie and it's uses in programming.</a></li>
                                </ul>
                            </p>

                            <p>
                                <b>Programming Challenges:</b>
                                If you have mastered Tries, write a program that Checks the
                                Spellings of words in a file, and quickly reports all the
                                misspelled words that exist. (Remember that the text is huge, so
                                implement an efficient algorithm). You can try submitting this
                                code <a href="https://docs.cs50.net/2018/x/psets/5/speller/speller.html">here</a>.
                            </p>

                            <p>
                                You can also start reading up on other varients/improvements over
                                Suffix Tries:
                                <ul>
                                    <li>Suffix Tries</li>
                                    <li>Suffix Arrays</li>
                                </ul>
                                Also, for searching in string do look up the module on:
                                <ul>
                                    <li>Knuth Morris Pratt (KMP) Algorithm</li>
                                </ul>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <script type="text/javascript" src="./js/loader.js"></script>
    </body>
</html>
